#!/bin/bash
# remove liveness and readiness files if any.
rm /tmp/ready /tmp/alive

# Need to mount debugfs - until we'll upgrade to libbpf v1.0.0
# Then we could mount tracefs instead and we'll do it in the operator
mount -t debugfs none /sys/kernel/debug

echo "Set up core persistant location"
echo "/var/opt/carbonblack/cores/core.%p" > /proc/sys/kernel/core_pattern
mkdir -p /var/opt/carbonblack/cores/

echo "Extract cb-psc-sensor tar"
mkdir -p /CNDR
tar -zxf cb-psc-sensor-docker.x86_64.tar.gz -C /CNDR --strip-components=1
mv -vf /CNDR/tmp/* /tmp
mv -vf /CNDR/opt/* /opt
rm -rf /tmp/var
mv -vf /CNDR/var/ /tmp

echo "Run post extract"
/tmp/cb_installer/post_extract.sh

echo "Cleanup old core files"
ls -t /var/opt/carbonblack/cores/core*  | sed -e '1d' | xargs rm

UNAME_R=$(uname -r)
echo "Get Kernelconfig"
if [ -f /opt/boot/config-$UNAME_R ]; then
    cp /opt/boot/config-$UNAME_R /boot
elif [ -f /var/opt/root/lib/modules/$UNAME_R/config ]; then # Openshift case
    cp /var/opt/root/lib/modules/$UNAME_R/config /boot/config-$UNAME_R
fi

if [ ! -f "/sys/kernel/btf/vmlinux" ]; then
    echo "BTF is not enabled, getting kernel headers"
    ln -sfn /var/opt/root/lib/modules /lib/modules
    ln -sfn /var/opt/root/usr/src /usr/src
fi

echo "Run install & start"
/tmp/cb_installer/install.sh && /tmp/cb_installer/start_agent.sh
